sc::FileGrp Class Referenceabstract

    The FileGrp abstract class provides a way of accessing distributed

file in a parallel machine. More...

`#include <file.h>`

Inheritance diagram for sc::FileGrp:
[legend]
Collaboration diagram for sc::FileGrp:
[legend]

## Public Member Functions

| FileGrp (const Ref< KeyVal > &)
void | open ()
| Opens the files.
void | close ()
| Closes the files.
void | set_filename (char *name)
| Sets the filename for the FileGrp.
const char * | get_filename () const
| Returns the filename for the FileGrp.
int | me () const
| Returns who I am.
int | n () const
| Returns how many nodes there are.
virtual void | set_localsize (size_t)=0
| Set the size of locally held data. More...
size_t | localsize ()
| Returns the amount of data residing locally on me().
distsize_t | localoffset ()
| Returns the global offset to this node's data.
int | size (int node)
| Returns the amount of data residing on node.
distsize_t | offset (int node)
| Returns the global offset to node's data.
distsize_t | totalsize ()
| Returns the sum of all data allocated on all nodes.
virtual void | activate ()
| Activate is called before the data is to be used.
virtual void | deactivate ()
| Deactivate is called after the data has been used.
virtual void * | obtain_writeonly (distsize_t offset, int size)=0
| This gives write access to the data location. No locking is done.
virtual void * | obtain_readwrite (distsize_t offset, int size)=0
| Only one thread can have an unreleased obtain_readwrite at a time. More...
virtual void * | obtain_readonly (distsize_t offset, int size)=0
| This gives read access to the file location. No locking is done.
virtual void | release_readonly (void *data, distsize_t offset, int size)=0
| This is called when read access is no longer needed.
virtual void | release_writeonly (void *data, distsize_t offset, int size)=0
| This is called when write access is no longer needed.
virtual void | release_readwrite (void *data, distsize_t offset, int size)=0
| This is called when read/write access is no longer needed. More...
virtual void | sum_reduction (double *data, distsize_t doffset, int dsize)
virtual void | sum_reduction_on_node (double *data, size_t doffset, int dsize, int node=-1)
virtual void | sync ()=0
| Synchronizes all the nodes. More...
virtual void | catchup ()
| Processes outstanding requests. More...
virtual void | print (std::ostream &o=ExEnv::out0()) const
| Prints out information about the object.
virtual FileGrp * | clone ()=0
| Clones the given FileGrp. The new FileGrp may need to be initialized additionally.
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Static Public Member Functions

static FileGrp * | initial_filegrp (int &argc, char **argv)
| Create a file group. More...
static FileGrp * | initial_filegrp ()
static void | set_default_filegrp (const Ref< FileGrp > &)
| The default file group contains the primary file group to be used by an application. More...
static FileGrp * | get_default_filegrp ()
| Returns the default file group.

## Protected Member Functions

void | obtain_local_lock (size_t start, size_t fence)
void | release_local_lock (size_t start, size_t fence)

## Protected Attributes

int | me_
int | n_
distsize_t * | offsets_
int | debug_

## Detailed Description

    The FileGrp abstract class provides a way of accessing distributed

file in a parallel machine.

Several specializations are available. For one processor, ProcFileGrp provides a simple stub implementation. Otherwise, the specializations that should work are MPIIOIFileGrp and MTMPIFileGrp.

If a FileGrp is not given to the program, then one will be automatically chosen depending on which MessageGrp is used by default, the type of machine on which the code was compiled, and what options were given at configuration time.

## Member Function Documentation

virtual void sc::FileGrp::catchup | ( |  | ) |

virtual

Processes outstanding requests.

Some file group implementations don't have access to real shared memory or even active messages. Instead, requests are processed whenever certain file group routines are called. This can cause large latencies and buffer overflows. If this is a problem, then the catchup member can be called to process all outstanding requests.

static FileGrp* sc::FileGrp::initial_filegrp | ( | int & | argc,
|  | char ** | argv
| ) |  |

static

Create a file group.

This routine looks for a -filegrp argument, then the environmental variable FILEGRP, and, finally, the default MessageGrp object to decide which specialization of FileGrp would be appropriate. The argument to -integralgrp should be either string for a ParsedKeyVal constructor or a classname. The default ThreadGrp and MessageGrp objects should be initialized before this is called.

virtual void* sc::FileGrp::obtain_readwrite | ( | distsize_t | offset,
|  | int | size
| ) |  |

pure virtual

Only one thread can have an unreleased obtain_readwrite at a time.

The actual file region locked can be larger than that requested. If the file region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implemented in sc::ProcFileGrp.

virtual void sc::FileGrp::release_readwrite | ( | void * | data,
|  | distsize_t | offset,
|  | int | size
| ) |  |

pure virtual

This is called when read/write access is no longer needed.

The data will be unlocked.

Implemented in sc::ProcFileGrp.

static void sc::FileGrp::set_default_filegrp | ( | const Ref< FileGrp > & |  | ) |

static

The default file group contains the primary file group to be used by an application.

virtual void sc::FileGrp::set_localsize | ( | size_t |  | ) |

pure virtual

Set the size of locally held data.

When data is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Implemented in sc::ProcFileGrp.

virtual void sc::FileGrp::sync | ( |  | ) |

pure virtual

Synchronizes all the nodes.

Consider using this when the way you you access data changes.

Implemented in sc::ProcFileGrp.

The documentation for this class was generated from the following file:

- file.h